﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CodeJonson
{
    internal class MethodCodeJonson
    {
        public void ReadStanksInFile(string path, ref List<int> stanokFirst, ref List<int> stanokSecond)
        {
            using (StreamReader sr = new StreamReader(path))
            {
                string line;
                while ((line = sr.ReadLine()) != null)
                {
                    string[] linesSplit = line.Split(' ');
                    stanokFirst.Add(int.Parse(linesSplit[0]));
                    stanokSecond.Add(int.Parse(linesSplit[1]));
                }
            }
        }
        public void WriteStanksInFile(string path, int[,] resultArray, int sumStart, int sumEnd)
        {
            using (StreamWriter writer = new StreamWriter(path))
            {
                for (int i = 0; i < resultArray.GetLength(0); i++)
                {
                    for (int j = 0; j < resultArray.GetLength(1); j++)
                    {
                        writer.Write(resultArray[i, j] + " ");
                    }
                    writer.WriteLine(); // Переход на новую строку
                }
                writer.WriteLine(sumStart);
                writer.WriteLine(sumEnd);
            }
        }
        public int[,] SortListStankofs(List<int> stanokFirst, List<int> stanokSecond)
        {
            int[,] resultItem = new int[stanokFirst.Count, 2];
            int endCountValue = 1;
            int startCountValue = 0;
            for (int i = 0; i < resultItem.GetLength(0); i++)
            {
                int valueTime = Math.Min(stanokFirst.Min(), stanokSecond.Min());
                if (stanokFirst.IndexOf(valueTime) == -1)
                {
                    int minValueTime = stanokSecond[stanokSecond.IndexOf(valueTime)];
                    resultItem[resultItem.GetLength(0) - endCountValue, 1] = minValueTime;
                    resultItem[resultItem.GetLength(0) - endCountValue, 0] = stanokFirst[stanokSecond.IndexOf(valueTime)];
                    stanokFirst.RemoveAt(stanokSecond.IndexOf(valueTime));
                    stanokSecond.RemoveAt(stanokSecond.IndexOf(valueTime));
                    endCountValue++;
                }
                else
                {
                    int minValueTime = stanokFirst[stanokFirst.IndexOf(valueTime)];
                    resultItem[startCountValue, 0] = minValueTime;
                    resultItem[startCountValue, 1] = stanokSecond[stanokFirst.IndexOf(valueTime)];
                    stanokSecond.RemoveAt(stanokFirst.IndexOf(valueTime));
                    stanokFirst.RemoveAt(stanokFirst.IndexOf(valueTime));
                    startCountValue++;
                }
            }
            return resultItem;

        }

        public int[,] SortArray(int[,] resultArray)
        {
            for (int i = 1; i < resultArray.GetLength(0); i++)
            {
                if (resultArray[i, 0] == resultArray[i - 1, 0])
                {
                    int maxValueTime = Math.Max(resultArray[i, 1], resultArray[i - 1, 1]);
                    if (resultArray[i, 1] == maxValueTime)
                    {
                        resultArray[i, 1] = resultArray[i - 1, 1];
                        resultArray[i - 1, 1] = maxValueTime;
                    }
                }
            }
            for (int i = 1; i < resultArray.GetLength(0); i++)
            {
                if (resultArray[i, 1] == resultArray[i - 1, 1])
                {
                    int minValueTime = Math.Min(resultArray[i, 0], resultArray[i - 1, 0]);
                    if (resultArray[i, 0] == minValueTime)
                    {
                        resultArray[i, 0] = resultArray[i - 1, 0];
                        resultArray[i - 1, 0] = minValueTime;
                    }
                }
            }
            return resultArray;
        }
        public int CountSumStanoks(int[,] resultArray)
        {
            List<int> result = new List<int>();
            List<int> stanokFirst = new List<int>();
            List<int> stanokSecond = new List<int>();
            for (int i = 0; i < resultArray.GetLength(0); i++) 
            {
                stanokFirst.Add(resultArray[i, 0]);
                stanokSecond.Add(resultArray[i, 1]);
            }

            for (int i = 0; i <= stanokFirst.Count; i++)
            {
                if (i == 0)
                {
                    result.Add(stanokFirst[i]);
                }
                result.Add(stanokFirst.Take(i).Sum() + (-1) * stanokSecond.Take(i-1).Sum());
            }
            return result.Max();
        }
        public int CountSumStanoks(List<int> stanokFirst, List<int> stanokSecond)
        {
            List<int> result = new List<int>();
            
            for (int i = 0; i <= stanokFirst.Count; i++)
            {
                if (i == 0)
                {
                    result.Add(stanokFirst[i]);
                }
                else result.Add(stanokFirst.Take(i).Sum() + (-1) * stanokSecond.Take(i - 1).Sum());
            }
            return result.Max();
        }
    }
}
